<html>
<head>
<title>OgreAnimationState.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreAnimationState.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreAnimationState_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __AnimationSet_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __AnimationSet_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreController_8h.html">OgreController.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00052"></a><a class="code" href="classOgre_1_1AnimationState.html">00052</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054     <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00057"></a><a class="code" href="classOgre_1_1AnimationState.html#a9eb388325ffd3d479e311a05f519445b">00057</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;float&gt;::type</a> <a class="code" href="classOgre_1_1AnimationState.html#a9eb388325ffd3d479e311a05f519445b" title="Typedef for an array of float values used as a bone blend mask.">BoneBlendMask</a>;
<a name="l00058"></a>00058 
<a name="l00073"></a>00073         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; animName, <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a> *parent, 
<a name="l00074"></a>00074             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <span class="keywordtype">bool</span> enabled = <span class="keyword">false</span>);
<a name="l00076"></a>00076         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>(<a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* parent, <span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a> &amp;rhs);
<a name="l00077"></a>00077         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>();
<a name="l00078"></a>00078         
<a name="l00080"></a>00080         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getAnimationName() <span class="keyword">const</span>;
<a name="l00082"></a>00082         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTimePosition(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00084"></a>00084         <span class="keywordtype">void</span> setTimePosition(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos);
<a name="l00086"></a>00086         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getLength() <span class="keyword">const</span>;
<a name="l00088"></a>00088         <span class="keywordtype">void</span> setLength(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> len);
<a name="l00090"></a>00090         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getWeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00092"></a>00092         <span class="keywordtype">void</span> setWeight(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight);
<a name="l00098"></a>00098         <span class="keywordtype">void</span> addTime(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> offset);
<a name="l00099"></a>00099 
<a name="l00101"></a>00101         <span class="keywordtype">bool</span> hasEnded(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00104"></a>00104         <span class="keywordtype">bool</span> getEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00106"></a>00106         <span class="keywordtype">void</span> setEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00107"></a>00107 
<a name="l00109"></a>00109         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00111"></a>00111         <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00112"></a>00112 
<a name="l00116"></a><a class="code" href="classOgre_1_1AnimationState.html#a1f6272f69d31ff9fdeca356cfcf0bc9d">00116</a>         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1AnimationState.html#a1f6272f69d31ff9fdeca356cfcf0bc9d" title="Sets whether or not an animation loops at the start and end of the animation if the time continues to...">setLoop</a>(<span class="keywordtype">bool</span> loop) { mLoop = loop; }
<a name="l00118"></a><a class="code" href="classOgre_1_1AnimationState.html#a0ec0b1f09ef22e7ef18a041e2fb30f29">00118</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationState.html#a0ec0b1f09ef22e7ef18a041e2fb30f29" title="Gets whether or not this animation loops.">getLoop</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mLoop; }
<a name="l00119"></a>00119      
<a name="l00124"></a>00124         <span class="keywordtype">void</span> copyStateFrom(<span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>&amp; animState);
<a name="l00125"></a>00125 
<a name="l00127"></a><a class="code" href="classOgre_1_1AnimationState.html#aadbf4450864c966da1911d600a673ff7">00127</a>         <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* <a class="code" href="classOgre_1_1AnimationState.html#aadbf4450864c966da1911d600a673ff7" title="Get the parent animation state set.">getParent</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mParent; }
<a name="l00128"></a>00128 
<a name="l00139"></a>00139       <span class="keywordtype">void</span> createBlendMask(<span class="keywordtype">size_t</span> blendMaskSizeHint, <span class="keywordtype">float</span> initialWeight = 1.0f);
<a name="l00141"></a>00141       <span class="keywordtype">void</span> destroyBlendMask();
<a name="l00149"></a>00149       <span class="keywordtype">void</span> _setBlendMaskData(<span class="keyword">const</span> <span class="keywordtype">float</span>* blendMaskData);
<a name="l00157"></a>00157       <span class="keywordtype">void</span> _setBlendMask(<span class="keyword">const</span> BoneBlendMask* blendMask);
<a name="l00159"></a><a class="code" href="classOgre_1_1AnimationState.html#a540dca3a99beca820013dca76cff68d1">00159</a>       <span class="keyword">const</span> <a class="code" href="classOgre_1_1AnimationState.html#a9eb388325ffd3d479e311a05f519445b" title="Typedef for an array of float values used as a bone blend mask.">BoneBlendMask</a>* <a class="code" href="classOgre_1_1AnimationState.html#a540dca3a99beca820013dca76cff68d1" title="Get the current blend mask (const version, may be 0)">getBlendMask</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> mBlendMask;}
<a name="l00161"></a><a class="code" href="classOgre_1_1AnimationState.html#accc8e63c8e9521e9a879d1df6169467b">00161</a>       <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationState.html#accc8e63c8e9521e9a879d1df6169467b" title="Return whether there is currently a valid blend mask set.">hasBlendMask</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> mBlendMask != 0;}
<a name="l00163"></a>00163       <span class="keywordtype">void</span> setBlendMaskEntry(<span class="keywordtype">size_t</span> boneHandle, <span class="keywordtype">float</span> weight);
<a name="l00165"></a><a class="code" href="classOgre_1_1AnimationState.html#a6e13e1f06b1c47aa3b9a7eeecc9474ea">00165</a>       <span class="keyword">inline</span> <span class="keywordtype">float</span> getBlendMaskEntry(<span class="keywordtype">size_t</span> boneHandle)<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword">      </span>{
<a name="l00167"></a>00167           assert(mBlendMask &amp;&amp; mBlendMask-&gt;size() &gt; boneHandle);
<a name="l00168"></a>00168           <span class="keywordflow">return</span> (*mBlendMask)[boneHandle];
<a name="l00169"></a>00169       }
<a name="l00170"></a>00170     <span class="keyword">protected</span>:
<a name="l00172"></a><a class="code" href="classOgre_1_1AnimationState.html#a2d5e8cd239d3091a650896f641bc5dd5">00172</a>         <a class="code" href="classOgre_1_1AnimationState.html#a9eb388325ffd3d479e311a05f519445b" title="Typedef for an array of float values used as a bone blend mask.">BoneBlendMask</a>* <a class="code" href="classOgre_1_1AnimationState.html#a2d5e8cd239d3091a650896f641bc5dd5" title="The blend mask (containing per bone weights)">mBlendMask</a>;
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classOgre_1_1AnimationState.html#a6aaecdb4c2d236c0a8b3b1af346e511e">00174</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1AnimationState.html#a6aaecdb4c2d236c0a8b3b1af346e511e">mAnimationName</a>;
<a name="l00175"></a><a class="code" href="classOgre_1_1AnimationState.html#a9c169c11fa2b35f0f9db9f68f69c0da0">00175</a>         <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>* <a class="code" href="classOgre_1_1AnimationState.html#a9c169c11fa2b35f0f9db9f68f69c0da0">mParent</a>;
<a name="l00176"></a><a class="code" href="classOgre_1_1AnimationState.html#aa524309374bba8a3eb05bac6c046ec1b">00176</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1AnimationState.html#aa524309374bba8a3eb05bac6c046ec1b">mTimePos</a>;
<a name="l00177"></a><a class="code" href="classOgre_1_1AnimationState.html#a17da018a960a834b8d16af2e811b535f">00177</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1AnimationState.html#a17da018a960a834b8d16af2e811b535f">mLength</a>;
<a name="l00178"></a><a class="code" href="classOgre_1_1AnimationState.html#a0e241844010a40259cf0eb28bcc68b98">00178</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1AnimationState.html#a0e241844010a40259cf0eb28bcc68b98">mWeight</a>;
<a name="l00179"></a><a class="code" href="classOgre_1_1AnimationState.html#a04f40a90d9464b5ed89ceb803b5e96d9">00179</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationState.html#a04f40a90d9464b5ed89ceb803b5e96d9">mEnabled</a>;
<a name="l00180"></a><a class="code" href="classOgre_1_1AnimationState.html#a4a6f3f2717fa461eaf22c04bf6528288">00180</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationState.html#a4a6f3f2717fa461eaf22c04bf6528288">mLoop</a>;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     };
<a name="l00183"></a>00183 
<a name="l00184"></a>00184     <span class="comment">// A map of animation states</span>
<a name="l00185"></a><a class="code" href="group__Animation.html#ga2fd1388ea690fecefc6bfe496d13e19f">00185</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;String, AnimationState*&gt;::type</a> <a class="code" href="group__Animation.html#ga2fd1388ea690fecefc6bfe496d13e19f">AnimationStateMap</a>;
<a name="l00186"></a><a class="code" href="group__Animation.html#gac427736c80940f4469fe0f4ac1694f67">00186</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;AnimationStateMap&gt;</a> <a class="code" href="group__Animation.html#gac427736c80940f4469fe0f4ac1694f67">AnimationStateIterator</a>;
<a name="l00187"></a><a class="code" href="group__Animation.html#gaad9cc8241f80d9d8fb4f112409de792f">00187</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstMapIterator&lt;AnimationStateMap&gt;</a> <a class="code" href="group__Animation.html#gaad9cc8241f80d9d8fb4f112409de792f">ConstAnimationStateIterator</a>;
<a name="l00188"></a>00188     <span class="comment">// A list of enabled animation states</span>
<a name="l00189"></a><a class="code" href="group__Animation.html#ga7f7651abe4d9e073cfdbcafd79da3511">00189</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;AnimationState*&gt;::type</a> <a class="code" href="group__Animation.html#ga7f7651abe4d9e073cfdbcafd79da3511">EnabledAnimationStateList</a>;
<a name="l00190"></a><a class="code" href="group__Animation.html#ga7bc761681d8c97c449763d8b77dcedf8">00190</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstVectorIterator&lt;EnabledAnimationStateList&gt;</a> <a class="code" href="group__Animation.html#ga7bc761681d8c97c449763d8b77dcedf8">ConstEnabledAnimationStateIterator</a>;
<a name="l00191"></a>00191 
<a name="l00194"></a><a class="code" href="classOgre_1_1AnimationStateSet.html">00194</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">AnimationAlloc</a>
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196     <span class="keyword">public</span>:
<a name="l00198"></a>00198         <a class="code" href="OgrePrerequisites_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a>
<a name="l00200"></a>00200         <a class="code" href="classOgre_1_1AnimationStateSet.html" title="Class encapsulating a set of AnimationState objects.">AnimationStateSet</a>();
<a name="l00202"></a>00202         AnimationStateSet(<span class="keyword">const</span> AnimationStateSet&amp; rhs);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204         ~AnimationStateSet();
<a name="l00205"></a>00205 
<a name="l00213"></a>00213         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* createAnimationState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; animName,  
<a name="l00214"></a>00214             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timePos, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> length, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> weight = 1.0, <span class="keywordtype">bool</span> enabled = <span class="keyword">false</span>);
<a name="l00216"></a>00216         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* getAnimationState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00218"></a>00218         <span class="keywordtype">bool</span> hasAnimationState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name) <span class="keyword">const</span>;
<a name="l00220"></a>00220         <span class="keywordtype">void</span> removeAnimationState(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00222"></a>00222         <span class="keywordtype">void</span> removeAllAnimationStates(<span class="keywordtype">void</span>);
<a name="l00223"></a>00223 
<a name="l00230"></a>00230         <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">AnimationStateIterator</a> getAnimationStateIterator(<span class="keywordtype">void</span>);
<a name="l00237"></a>00237         <a class="code" href="classOgre_1_1ConstMapIterator.html" title="Concrete IteratorWrapper for const access to the underlying key-value container.">ConstAnimationStateIterator</a> getAnimationStateIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00239"></a>00239         <span class="keywordtype">void</span> copyMatchingState(AnimationStateSet* target) <span class="keyword">const</span>;
<a name="l00241"></a>00241         <span class="keywordtype">void</span> _notifyDirty(<span class="keywordtype">void</span>);
<a name="l00243"></a><a class="code" href="classOgre_1_1AnimationStateSet.html#a922432730b6857b4e7d658b410d1ca68">00243</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1AnimationStateSet.html#a922432730b6857b4e7d658b410d1ca68" title="Get the latest animation state been altered frame number.">getDirtyFrameNumber</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDirtyFrameNumber; }
<a name="l00244"></a>00244 
<a name="l00246"></a>00246         <span class="keywordtype">void</span> _notifyAnimationStateEnabled(<a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* target, <span class="keywordtype">bool</span> enabled);
<a name="l00248"></a><a class="code" href="classOgre_1_1AnimationStateSet.html#ad45ccbbf5fa04e2fc20dd5b7d96e87df">00248</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1AnimationStateSet.html#ad45ccbbf5fa04e2fc20dd5b7d96e87df" title="Tests if exists enabled animation state in this set.">hasEnabledAnimationState</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> !mEnabledAnimationStates.empty(); }
<a name="l00255"></a>00255         <a class="code" href="classOgre_1_1ConstVectorIterator.html" title="Concrete IteratorWrapper for const access to the underlying container.">ConstEnabledAnimationStateIterator</a> getEnabledAnimationStateIterator(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     <span class="keyword">protected</span>:
<a name="l00258"></a><a class="code" href="classOgre_1_1AnimationStateSet.html#a5c0d0e57eb7f6fc084e7577681742e01">00258</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classOgre_1_1AnimationStateSet.html#a5c0d0e57eb7f6fc084e7577681742e01">mDirtyFrameNumber</a>;
<a name="l00259"></a><a class="code" href="classOgre_1_1AnimationStateSet.html#a48eed73e9a54596baa542fca3e7b3a9f">00259</a>         <a class="code" href="group__Animation.html#ga2fd1388ea690fecefc6bfe496d13e19f">AnimationStateMap</a> <a class="code" href="classOgre_1_1AnimationStateSet.html#a48eed73e9a54596baa542fca3e7b3a9f">mAnimationStates</a>;
<a name="l00260"></a><a class="code" href="classOgre_1_1AnimationStateSet.html#a25c872cca9cf791a0ccb62feacf63e38">00260</a>         <a class="code" href="group__Animation.html#ga7f7651abe4d9e073cfdbcafd79da3511">EnabledAnimationStateList</a> <a class="code" href="classOgre_1_1AnimationStateSet.html#a25c872cca9cf791a0ccb62feacf63e38">mEnabledAnimationStates</a>;
<a name="l00261"></a>00261 
<a name="l00262"></a>00262     };
<a name="l00263"></a>00263 
<a name="l00272"></a><a class="code" href="classOgre_1_1AnimationStateControllerValue.html">00272</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationStateControllerValue.html" title="ControllerValue wrapper class for AnimationState.">AnimationStateControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274     <span class="keyword">protected</span>:
<a name="l00275"></a><a class="code" href="classOgre_1_1AnimationStateControllerValue.html#a704120944d35dad25859a6f2bd5f8fc5">00275</a>         <a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* <a class="code" href="classOgre_1_1AnimationStateControllerValue.html#a704120944d35dad25859a6f2bd5f8fc5">mTargetAnimationState</a>;
<a name="l00276"></a>00276     <span class="keyword">public</span>:
<a name="l00278"></a><a class="code" href="classOgre_1_1AnimationStateControllerValue.html#aeb2ae06f4c83bb901a21a60e8071b2ae">00278</a>         <a class="code" href="classOgre_1_1AnimationStateControllerValue.html" title="ControllerValue wrapper class for AnimationState.">AnimationStateControllerValue</a>(<a class="code" href="classOgre_1_1AnimationState.html" title="Represents the state of an animation and the weight of its influence.">AnimationState</a>* targetAnimationState)
<a name="l00279"></a>00279             : mTargetAnimationState(targetAnimationState) {}
<a name="l00281"></a><a class="code" href="classOgre_1_1AnimationStateControllerValue.html#a252f8e4d8d9a3f0589ac45f75a97a24a">00281</a>         <a class="code" href="classOgre_1_1AnimationStateControllerValue.html#a252f8e4d8d9a3f0589ac45f75a97a24a" title="Destructor (parent already virtual)">~AnimationStateControllerValue</a>() {}
<a name="l00283"></a>00283         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00284"></a>00284 
<a name="l00286"></a>00286         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288     };
<a name="l00289"></a>00289 
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="preprocessor">#endif</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
